#!/usr/local/bin/python

import getopt
import shutil
import subprocess
import sys


def transcode(src, tgt, fmt):
	transcode_opts = [ "ffmpeg" ];
	#transcode_opts = [ "ffmpeg-devel" ];
	#transcode_opts.extend(["-t", "240"]) # testing only
	#transcode_opts.extend(["-loglevel", "debug"])
	transcode_opts.extend(["-i", src])

	transcode_opts.extend(["-threads", "0"])
   	transcode_opts.extend(["-y", "-deinterlace"])
	#transcode_opts.extend(["-ac", "2", "-ab", "128k"])
	transcode_opts.extend(["-c:a", "libfdk_aac", "-ab", "192k"])
	transcode_opts.extend(["-vcodec", "libx264"])
	#transcode_opts.extend(["-tune", "film", "-profile", "main"])
	if fmt == "hd":
		transcode_opts.extend(["-s",  "1280x720"])
		transcode_opts.extend(["-b:v", "3000k"])
		transcode_opts.append(tgt)
	elif fmt == "hdsmall":
		transcode_opts.extend(["-s",  "640x360"])
		transcode_opts.extend(["-b:v", "1000k"])
		transcode_opts.extend(["-vsync", "1"])
		transcode_opts.append(tgt)
	else:
		transcode_opts.extend(["-b:v", "900k", "-bt", "900k"])
		if str(fmt) == "169":
			transcode_opts.extend(["-vf", "crop=640:360"])
			transcode_opts.extend(["-aspect",  "16:9"])
		elif str(fmt) == "149":
			transcode_opts.extend(["-vf", "crop=640:412"])
			transcode_opts.extend(["-aspect",  "14:9"])
		transcode_opts.extend(["-vsync", "1"])
		transcode_opts.append(tgt)
		#if getInfo(src)[0] == "a":
			#transcode_opts.extend(["-map", "0.1:0.0", "-map", "0.0:0.0"])
			#transcode_opts.extend(["-map", "0.1:0.1", "-map", "0.0:0.1"])

	print "    \"%s\"" % "\" \"".join(transcode_opts)
	subprocess.check_call(transcode_opts)


def getInfo(src):
	c = []
	o = [ "ffmpeg" ];
	o.extend(["-i", src])
	try:
		p = subprocess.Popen(o, stderr=subprocess.PIPE)
		(out, err) = p.communicate()
	except subprocess.CalledProcessError, e:
		pass
	for l in err.split("\n"):
		if l.find("Stream #") >=0:
			w = l.split()
			if w[2] == "Audio:":
				c.extend(["a"])
			elif w[2] == "Video:":
				c.extend(["v"])
			else:
				c.extend(["?"])
	return c

class Usage(Exception):
	def __init__(self, msg):
		self.msg = msg;
	def __str__(self):
		return repr(self.msg)


def main(argv=None):
	if argv is None:
		argv = sys.argv
   	try:
   		try:
			opts, args = getopt.getopt(argv[1:], "hi:", ["help"])
		except getopt.error, msg:
			raise Usage(msg)
		for (o, v) in opts:
			if o == "-h":
				print >>sys.stderr, "help text"
				return 0
			if o == "-i":
				print getInfo(v)
				return 0
		if len(args) != 3:
			raise Usage("wrong number of arguments")
		transcode(args[1], args[2], args[0])
	except Usage, err:
		print >>sys.stderr, err.msg
		print >>sys.stderr, "tivomp4 format source destination"
		print >>sys.stderr, "for help use --help"
		return 64
                                                                                             
if __name__ == "__main__":
	sys.exit(main())
